( function( $ ) {
"use strict";
	function wbb_getEnhancedSelectFormatString() {
		return {
			'language': {
				errorLoading: function() {
					return wc_enhanced_select_params.i18n_searching;
				},
				inputTooLong: function( args ) {
					var overChars = args.input.length - args.maximum;
					if ( 1 === overChars ) {
						return wc_enhanced_select_params.i18n_input_too_long_1;
					}
					return wc_enhanced_select_params.i18n_input_too_long_n.replace( '%qty%', overChars );
				},
				inputTooShort: function( args ) {
					var remainingChars = args.minimum - args.input.length;
					if ( 1 === remainingChars ) {
						return wc_enhanced_select_params.i18n_input_too_short_1;
					}
					return wc_enhanced_select_params.i18n_input_too_short_n.replace( '%qty%', remainingChars );
				},
				loadingMore: function() {
					return wc_enhanced_select_params.i18n_load_more;
				},
				maximumSelected: function( args ) {
					if ( args.maximum === 1 ) {
						return wc_enhanced_select_params.i18n_selection_too_long_1;
					}
					return wc_enhanced_select_params.i18n_selection_too_long_n.replace( '%qty%', args.maximum );
				},
				noResults: function() {
					return wc_enhanced_select_params.i18n_no_matches;
				},
				searching: function() {
					return wc_enhanced_select_params.i18n_searching;
				}
			}
		};
	}
function wpf_select2() {
	jQuery( ':input.wc-product-search' ).filter( ':not(.enhanced)' ).each( function() {
		var select2_args = {
			allowClear:  jQuery( this ).data( 'allow_clear' ) ? true : false,
			placeholder: jQuery( this ).data( 'placeholder' ),
			minimumInputLength: jQuery( this ).data( 'minimum_input_length' ) ? jQuery( this ).data( 'minimum_input_length' ) : '3',
			escapeMarkup: function( m ) {
				return m;
			},
			ajax: {
				url      : wc_enhanced_select_params.ajax_url,
				dataType : 'json',
				delay    : 250,
				data     : function( params ) {
					return {
						term          : params.term,
						action        : jQuery( this ).data( 'action' ) || 'woocommerce_json_search_products_and_variations',
						security      : wc_enhanced_select_params.search_products_nonce,
						exclude       : jQuery( this ).data( 'exclude' ),
						exclude_type  : jQuery( this ).data( 'exclude_type' ),
						include       : jQuery( this ).data( 'include' ),
						limit         : jQuery( this ).data( 'limit' ),
						display_stock : jQuery( this ).data( 'display_stock' )
					};
				},
				processResults: function( data ) {
					var terms = [];
					if ( data ) {
						jQuery.each( data, function( id, text ) {
							terms.push( { id: id, text: text } );
						});
					}
					return {
						results: terms
					};
				},
				cache: true
			}
		};
		select2_args = jQuery.extend(select2_args, wbb_getEnhancedSelectFormatString());
		jQuery(this).selectWoo(select2_args).addClass('enhanced');
	});
}
function wpf_show_fields(obj, hide_show_fields){
	jQuery('.wpf_label_format, .wpf_option_required, .wpf_text_field_restriction, .wpf_html-shortcode, .wpf_option_text_pricing, .wpf_images, .wpf_option_allow_multiple, .wpf_options_limit, .wpf_option_products, .wpf_option_price, .wpf_quantity_option, .wpf_add_options, .wpf_price_option').hide();
	jQuery('.wpf_rules_fields').find('.wpf_rule_fields').hide();
	obj.closest('.wpf_rules_fields').find('.wpf_rule_fields').show();
	switch(hide_show_fields){
		case 'checkboxes':
			obj.closest('.wpf_rules_fields').find('.wpf_add_options').show();
			obj.closest('.wpf_rules_fields').find('.wpf_label_format').show();
			obj.closest('.wpf_rules_fields').find('.wpf_option_required').show();
		break;
		case 'dropdown':
			obj.closest('.wpf_rules_fields').find('.wpf_add_options').show();
			obj.closest('.wpf_rules_fields').find('.wpf_label_format').show();
			obj.closest('.wpf_rules_fields').find('.wpf_option_required').show();
		break;
		case 'radio':
			obj.closest('.wpf_rules_fields').find('.wpf_add_options').show();
			obj.closest('.wpf_rules_fields').find('.wpf_label_format').show();
			obj.closest('.wpf_rules_fields').find('.wpf_option_required').show();
		break;
		case 'text_field':
			obj.closest('.wpf_rules_fields').find('.wpf_text_field_restriction').show();
			obj.closest('.wpf_rules_fields').find('.wpf_options_limit').show();
			obj.closest('.wpf_rules_fields').find('.wpf_option_price').show();
			obj.closest('.wpf_rules_fields').find('.wpf_label_format').show();
			obj.closest('.wpf_rules_fields').find('.wpf_option_required').show();
		break;
		case 'text_area':
			obj.closest('.wpf_rules_fields').find('.wpf_options_limit').show();
			obj.closest('.wpf_rules_fields').find('.wpf_option_price').show();
			obj.closest('.wpf_rules_fields').find('.wpf_label_format').show();
			obj.closest('.wpf_rules_fields').find('.wpf_option_required').show();
			obj.closest('.wpf_rules_fields').find('.wpf_option_text_pricing').show();
		break;
		case 'file':
			obj.closest('.wpf_rules_fields').find('.wpf_option_required').show();
			obj.closest('.wpf_rules_fields').find('.wpf_option_price').show();
			obj.closest('.wpf_rules_fields').find('.wpf_label_format').show();
		break;
		case 'time':
			obj.closest('.wpf_rules_fields').find('.wpf_option_required').show();
			obj.closest('.wpf_rules_fields').find('.wpf_option_price').show();
			obj.closest('.wpf_rules_fields').find('.wpf_label_format').show();
		break;
		case 'date':
			obj.closest('.wpf_rules_fields').find('.wpf_option_required').show();
			obj.closest('.wpf_rules_fields').find('.wpf_option_price').show();
			obj.closest('.wpf_rules_fields').find('.wpf_label_format').show();
		break;
		case 'multiselect':
			obj.closest('.wpf_rules_fields').find('.wpf_option_required').show();
			obj.closest('.wpf_rules_fields').find('.wpf_label_format').show();
			obj.closest('.wpf_rules_fields').find('.wpf_add_options').show();
		break;
		case 'colorpicker':
			obj.closest('.wpf_rules_fields').find('.wpf_option_required').show();
			obj.closest('.wpf_rules_fields').find('.wpf_option_price').show();
			obj.closest('.wpf_rules_fields').find('.wpf_label_format').show();
		break;
		case 'quantity':
			obj.closest('.wpf_rules_fields').find('.wpf_option_price').show();
			obj.closest('.wpf_rules_fields').find('.wpf_quantity_option').show();
			obj.closest('.wpf_rules_fields').find('.wpf_label_format').show();
			obj.closest('.wpf_rules_fields').find('.wpf_option_required').show();
		break;
		case 'price':
			obj.closest('.wpf_rules_fields').find('.wpf_price_option').show();
			obj.closest('.wpf_rules_fields').find('.wpf_label_format').show();
			obj.closest('.wpf_rules_fields').find('.wpf_option_required').show();
		break;
		case 'heading':
			obj.closest('.wpf_rules_fields').find('.wpf_label_format').hide();
			obj.closest('.wpf_rules_fields').find('.wpf_option_required').hide();
		break;
		case 'images':
			obj.closest('.wpf_rules_fields').find('.wpf_option_required').show();
			obj.closest('.wpf_rules_fields').find('.wpf_label_format').show();
			obj.closest('.wpf_rules_fields').find('.wpf_add_options').show();
			obj.closest('.wpf_rules_fields').find('.wpf_images').show();
			obj.closest('.wpf_rules_fields').find('.wpf_option_allow_multiple').show();
		break;
		case 'range_picker':
			obj.closest('.wpf_rules_fields').find('.wpf_quantity_option').show();
			obj.closest('.wpf_rules_fields').find('.wpf_option_price').show();
			obj.closest('.wpf_rules_fields').find('.wpf_label_format').show();
			obj.closest('.wpf_rules_fields').find('.wpf_option_required').show();
		break;
		case 'date_range_picker':
			obj.closest('.wpf_rules_fields').find('.wpf_option_price').show();
			obj.closest('.wpf_rules_fields').find('.wpf_label_format').show();
			obj.closest('.wpf_rules_fields').find('.wpf_option_required').show();
		break;
		case 'composite_products':
			obj.closest('.wpf_rules_fields').find('.wpf_option_price').hide();
			obj.closest('.wpf_rules_fields').find('.wpf_label_format').show();
			obj.closest('.wpf_rules_fields').find('.wpf_option_required').show();
			obj.closest('.wpf_rules_fields').find('.wpf_options_cols').show();
			obj.closest('.wpf_rules_fields').find('.wpf_option_allow_multiple').show();
			obj.closest('.wpf_rules_fields').find('.wpf_option_products').show();
			break;
		case 'shortcode-html':
			obj.closest('.wpf_rules_fields').find('.wpf_html-shortcode').show();
			break;
	}
}
function wpf_options_indexing() {
	var i = 0, j = 0, k = 0, l = 0;
	jQuery('input.wpf_option_required').each(function(){
		jQuery(this).attr('name', 'wpf_option_required['+i+']');
		i++;
	});
	jQuery('input.wpf_option_allow_multiple').each(function(){
		jQuery(this).attr('name', 'wpf_option_allow_multiple['+k+']');
		k++;
	});
	jQuery('input.wpf_option_text_pricing').each(function(){
		jQuery(this).attr('name', 'wpf_option_text_pricing['+l+']');
		l++;
	});
	jQuery('.wpf_rules_fields').each(function(){
		jQuery(this).closest('.wpf_rules_fields').find('.wpf_multi_options_label').attr('name', 'wpf_multi_options_label['+j+'][]');
		jQuery(this).closest('.wpf_rules_fields').find('.wpf_multi_options_image').attr('name', 'wpf_multi_options_image['+j+'][]');
		jQuery(this).closest('.wpf_rules_fields').find('.wpf_multi_options_price_type').attr('name', 'wpf_multi_options_price_type['+j+'][]');
		jQuery(this).closest('.wpf_rules_fields').find('.wpf_multi_options_price').attr('name', 'wpf_multi_options_price['+j+'][]');
		j++;
	});
}
function wpf_options_title() {
	var obj = [];
	jQuery('.wpf_rules_fields').each(function( i ) {
		obj[i] = jQuery(this).find('input.wpf_option_label').val();
	});
	// return obj;
	var options = '';
	for ( var i = 0; i < obj.length; i++ ) {
		options += '<option value="'+i+'">'+obj[i]+'</option>';
	}
	jQuery('.wpf_rules_fields').each(function() {
		jQuery(this).find('.wpf_logic_option').html(options);
	});
}
	jQuery( document ).ready( function() {
		if( jQuery( '.wpf_color_picker' ).length > 0 ) {
            jQuery( '.wpf_color_picker' ).wpColorPicker();
		}
		jQuery(document).on('click', '.wpf_add_option', function(e){
			e.preventDefault();
			jQuery('.wpf_option_products:last .wc-product-search').selectWoo('destroy');
			jQuery('.wpf_option_products:last .wc-product-search').removeClass('enhanced');
			var clone = jQuery('.wpf_rules_fields:last').clone();
			clone.insertAfter(jQuery('.wpf_rules_fields:last'));
			wpf_options_indexing();
			wpf_options_title();
			wpf_select2();
		});
		jQuery(document).on('click', '.wpf_remove', function(e){
			e.preventDefault();
			if ( jQuery('.wpf_rules_fields').length > 1 ) {
				jQuery(this).closest('.wpf_rules_fields').remove();
				wpf_options_indexing();
				wpf_options_title();
			}
		});
		jQuery(document).on('change', '.wpf_option_label', function() {
			wpf_options_title();
		});
		jQuery(document).on('click', '.wpf_fields_header', function() {
			jQuery(this).closest('.wpf_rules_fields').find('.wpf_rule_fields').slideToggle();
			var hide_show_fields = jQuery(this).closest('.wpf_rules_fields').find('select.wpf_rule_type').val();
			var obj = jQuery(this);
			wpf_show_fields(obj, hide_show_fields);
		});
		jQuery(document).on('change', '.wpf_rule_type', function(){
			var obj = jQuery(this);
			jQuery(this).closest('.wpf_rules_fields').find('span.wpf_option_title').html(jQuery(this).val());
			wpf_show_fields(obj, jQuery(this).val());
		});
		jQuery(document).on('click', '.wpf_add_field_options', function(e){
			e.preventDefault();
			var i = 0;
			var clone = jQuery(this).closest('.wpf_add_options').find('table tr.wpf_field_options:last').clone();
			jQuery(this).closest('.wpf_add_options').find('table').append(clone);
		});
		jQuery(document).on('click', '.wpf_remove_options', function( e ){
			e.preventDefault();
			if ( jQuery(this).closest('table').find('.wpf_field_options').length > 1) {
				jQuery(this).closest('.wpf_field_options').remove();
			}
		});
		jQuery(document).on('click', 'a.wpf_image_options', function( e ) {
			e.preventDefault();
			var obj = jQuery(this);
			var custom_uploader = wp.media({
				multiple: false
			}).on('select', function() {
				var attachment = custom_uploader.state().get('selection').first().toJSON();
				obj.find('img').attr('src', attachment.url);
				obj.find('input[type="hidden"]').val(attachment.id);
			}).open();
		});
		if ( jQuery('.wpf_fields_section').length > 0 ) {
			jQuery('.wpf_fields_section').sortable({
				handle : '.wpf_move_option',
				update : function (event, ui) {
					wpf_options_indexing();
					wpf_options_title();
				}
			});
		}
	});
})(jQuery);