<?php
if ( !defined('ABSPATH') ) {
	wp_die(); 
}
if ( !class_exists('WPF_Options_Settings') ) {
	class WPF_Options_Settings {
		public static function wpf_labels_settings() { ?>
			<form method="post" action="options.php">
				<?php settings_errors();
				settings_fields('wpf_labels_settings');
				do_settings_sections('wpf_labels_settings'); ?>
				<h3><?php esc_html_e('General Settings', 'wc-wpf'); ?></h3>
				<table class="form-table">
					<tr>
						<?php $value = get_option('wpf_hide_addons_price'); ?>
						<th><label for="wpf_hide_addons_price"><?php esc_html_e('Hide Addons Price', 'wc-wpf'); ?></label></th>
						<td><label><input type="checkbox" name="wpf_hide_addons_price" class="regular-text" id="wpf_hide_addons_price" value="yes" <?php checked('yes', $value); ?> />
							<?php esc_html_e('Hide product addons price.', 'wc-wpf'); ?></label></td>
					</tr>
					<tr>
						<?php $value = get_option('wpf_hide_summary_table'); ?>
						<th><label for="wpf_hide_summary_table"><?php esc_html_e('Hide Summary Table', 'wc-wpf'); ?></label></th>
						<td><label><input type="checkbox" name="wpf_hide_summary_table" class="regular-text" id="wpf_hide_summary_table" value="yes" <?php checked('yes', $value); ?> />
							<?php esc_html_e('Hide addons summary table.', 'wc-wpf'); ?></label></td>
					</tr>
					<tr>
						<?php $value = get_option('wpf_hide_images_title'); ?>
						<th><label for="wpf_hide_images_title"><?php esc_html_e('Hide Images Title', 'wc-wpf'); ?></label></th>
						<td><label><input type="checkbox" name="wpf_hide_images_title" class="regular-text" id="wpf_hide_images_title" value="yes" <?php checked('yes', $value); ?> />
							<?php esc_html_e('Hide product addon images title.', 'wc-wpf'); ?></label></td>
					</tr>
					<tr>
						<?php $value = get_option('wpf_dropdown_select_label'); ?>
						<th><label for="wpf_dropdown_select_label"><?php esc_html_e('Dropdown Select Option Label', 'wc-wpf'); ?></label></th>
						<td><input type="text" name="wpf_dropdown_select_label" class="regular-text" id="wpf_dropdown_select_label" value="<?php echo esc_attr($value); ?>" /></td>
					</tr>
                    <tr>
						<?php $value = get_option('wpf_total_price_label'); ?>
						<th><label for="wpf_total_price_label"><?php esc_html_e('Total Price Label', 'wc-wpf'); ?></label></th>
						<td><input type="text" name="wpf_total_price_label" class="regular-text" id="wpf_total_price_label" value="<?php echo esc_attr($value); ?>" /></td>
					</tr>
                    <tr>
						<?php $value = get_option('wpf_table_options_label'); ?>
						<th><label for="wpf_table_options_label"><?php esc_html_e('Table Title \'Options\' Label', 'wc-wpf'); ?></label></th>
						<td><input type="text" name="wpf_table_options_label" class="regular-text" id="wpf_table_options_label" value="<?php echo esc_attr($value); ?>" /></td>
					</tr>
                    <tr>
						<?php $value = get_option('wpf_table_price_label'); ?>
						<th><label for="wpf_table_price_label"><?php esc_html_e('Table Title \'Price\' ', 'wc-wpf'); ?></label></th>
						<td><input type="text" name="wpf_table_price_label" class="regular-text" id="wpf_table_price_label" value="<?php echo esc_attr($value); ?>" /></td>
					</tr>
                    <tr>
						<?php $value = get_option('wpf_shop_page_product_button_label'); ?>
						<th><label for="wpf_shop_page_product_button_label"><?php esc_html_e('Shop Page Button Label', 'wc-wpf'); ?></label></th>
						<td><input type="text" name="wpf_shop_page_product_button_label" class="regular-text" id="wpf_shop_page_product_button_label" value="<?php echo esc_attr($value); ?>" /></td>
					</tr>
					<tr>
						<?php $value = get_option('wpf_border_color'); ?>
						<th><label for="wpf_border_color"><?php esc_html_e('Image Border Color', 'wc-wpf'); ?></label></th>
						<td><input type="text" name="wpf_border_color" class="wpf_color_picker" id="wpf_border_color" value="<?php echo esc_attr($value); ?>" /></td>
					</tr>
				</table>
				<?php submit_button(); ?>
			</form>
			<?php
		}
	}
	new WPF_Options_Settings();
}